function poolstackspks=getPoolStackSpks(subjsData)

opts = struct('WindowStyle','modal','Interpreter','none','Default','No');
answer = questdlg('This requires available memory at runtime. Are you sure to continue?','Memory Warning','Yes','No',opts);
if strcmpi(answer,'No'); error('Aborted getting pool stack eye position (consider loading getPoolStackSpksOutput.mat).'); end

disp('Loading spike data...');

subject1=subjsData(1).sbdata;
subject2=subjsData(2).sbdata;

twLabels={'preoffer1','offer1','delay1','offer2','delay2','startfix','choicego','choicesacc','choicemade'};

for tw=1:8
    currtws1s1gss=getSpikeSequences(subject1,1,twLabels{tw},twLabels{tw+1});
    currtws1s2gss=getSpikeSequences(subject1,2,twLabels{tw},twLabels{tw+1});
    currtws1s3gss=getSpikeSequences(subject1,3,twLabels{tw},twLabels{tw+1});
    currtws1s4gss=getSpikeSequences(subject1,4,twLabels{tw},twLabels{tw+1});
    
    currtws2s1gss=getSpikeSequences(subject2,1,twLabels{tw},twLabels{tw+1});
    currtws2s2gss=getSpikeSequences(subject2,2,twLabels{tw},twLabels{tw+1});
    currtws2s3gss=getSpikeSequences(subject2,3,twLabels{tw},twLabels{tw+1});
    currtws2s4gss=getSpikeSequences(subject2,4,twLabels{tw},twLabels{tw+1});
    
    s1s1poolstackspks(tw).spksq = currtws1s1gss.spikeseqs;
    s1s2poolstackspks(tw).spksq = currtws1s2gss.spikeseqs;
    s1s3poolstackspks(tw).spksq = currtws1s3gss.spikeseqs;
    s1s4poolstackspks(tw).spksq = currtws1s4gss.spikeseqs;
    s2s1poolstackspks(tw).spksq = currtws2s1gss.spikeseqs;
    s2s2poolstackspks(tw).spksq = currtws2s2gss.spikeseqs;
    s2s3poolstackspks(tw).spksq = currtws2s3gss.spikeseqs;
    s2s4poolstackspks(tw).spksq = currtws2s4gss.spikeseqs;
end

for tw=1:8
    for sn=1:4
        poolstackspks(sn,tw).spksq  =eval(['s1s' num2str(sn) 'poolstackspks(tw).spksq']);
        poolstackspks(sn+4,tw).spksq=eval(['s2s' num2str(sn) 'poolstackspks(tw).spksq']);
    end
end

end
